/* This file is is generated by a shell script.  DO NOT EDIT! */

/* emulate the original gld for the given msp430
   Copyright 1991, 1992, 1994, 1996, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
   2007 Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com

   This file is part of the GNU Binutils.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
   MA 02110-1301, USA.  */

#define TARGET_IS_msp430

#include "sysdep.h"
#include "bfd.h"
#include "bfdlink.h"

#include "ld.h"
#include "ldmain.h"
#include "ldmisc.h"

#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"

#include "elf-bfd.h"
#include "libbfd.h"
#include "elf/msp430.h"


static void
gldmsp430_map_segments (bfd_boolean need_layout)
{
  int tries = 10;

  do
    {
      lang_relax_sections (need_layout);
      need_layout = FALSE;

      if (link_info.output_bfd->xvec->flavour == bfd_target_elf_flavour
	  && !link_info.relocatable)
	{
	  bfd_size_type phdr_size;

	  phdr_size = elf_tdata (link_info.output_bfd)->program_header_size;
	  /* If we don't have user supplied phdrs, throw away any
	     previous linker generated program headers.  */
	  if (lang_phdr_list == NULL)
	    elf_tdata (link_info.output_bfd)->segment_map = NULL;
	  if (!_bfd_elf_map_sections_to_segments (link_info.output_bfd,
						  &link_info))
	    einfo ("%F%P: map sections to segments failed: %E\n");

	  if (phdr_size
	      != elf_tdata (link_info.output_bfd)->program_header_size)
	    {
	      if (tries > 6)
		/* The first few times we allow any change to
		   phdr_size .  */
		need_layout = TRUE;
	      else if (phdr_size
		       < elf_tdata (link_info.output_bfd)->program_header_size)
		/* After that we only allow the size to grow.  */
		need_layout = TRUE;
	      else
		elf_tdata (link_info.output_bfd)->program_header_size
		  = phdr_size;
	    }
	}
    }
  while (need_layout && --tries);

  if (tries == 0)
    einfo (_("%P%F: looping in map_segments"));
}

static void
gldmsp430_after_open (void)
{
  bfd *ibfd;
  asection *sec;
  asymbol **syms;

  after_open_default ();

  if (link_info.relocatable)
    for (ibfd = link_info.input_bfds; ibfd != NULL; ibfd = ibfd->link_next)
      if ((syms = bfd_get_outsymbols (ibfd)) != NULL
	  && bfd_get_flavour (ibfd) == bfd_target_elf_flavour)
	for (sec = ibfd->sections; sec != NULL; sec = sec->next)
	  if ((sec->flags & (SEC_GROUP | SEC_LINKER_CREATED)) == SEC_GROUP)
	    {
	      struct bfd_elf_section_data *sec_data = elf_section_data (sec);
	      elf_group_id (sec) = syms[sec_data->this_hdr.sh_info - 1];
	    }
}

static void
gldmsp430_before_allocation (void)
{
  if (link_info.relocatable
      && !_bfd_elf_size_group_sections (&link_info))
    einfo ("%X%P: can not size group sections: %E\n");
  before_allocation_default ();
}

static void
gldmsp430_after_allocation (void)
{
  gldmsp430_map_segments (FALSE);
}

static void
gldmsp430_finish (void)
{
  bfd *obfd = link_info.output_bfd;
  Elf_Internal_Ehdr *o_ehdrp = elf_elfheader (obfd);
  unsigned long flags = 0;
  bfd *ibfd;

  for (ibfd = link_info.input_bfds; ibfd != NULL; ibfd = ibfd->link_next) {
    Elf_Internal_Ehdr * i_ehdrp = elf_elfheader (ibfd);

    if (EF_MSP430_UNIARCH & i_ehdrp->e_flags)
      flags |= i_ehdrp->e_flags;
  }
  if (EF_MSP430_UNIARCH & flags) {
    int bfd_mach;
    switch (flags & EF_MSP430_ARCH)
      {
      default:
      case EF_MSP430_ARCH_430:
        bfd_mach = bfd_mach_msp430;
        break;
      case EF_MSP430_ARCH_430X:
        bfd_mach = bfd_mach_msp430x;
        break;
      }
    bfd_default_set_arch_mach (obfd, bfd_arch_msp430, bfd_mach);
    o_ehdrp->e_flags = flags;
  }
  finish_default();
}

static void
gldmsp430_before_parse (void)
{
#ifndef TARGET_			/* I.e., if not generic.  */
  ldfile_set_output_arch ("msp430", bfd_arch_unknown);
#endif /* not TARGET_ */
}


static char *
gldmsp430_get_script (int *isfile)
{
  *isfile = 0;

  if (link_info.relocatable && config.build_constructors)
    return
"/* Script for ld -Ur: link w/out relocation, do create constructors */\n\
OUTPUT_FORMAT(\"elf32-msp430\")\n\
OUTPUT_ARCH(\"msp430\")\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          0 : { *(.hash)          }\n\
  .dynsym        0 : { *(.dynsym)        }\n\
  .dynstr        0 : { *(.dynstr)        }\n\
  .gnu.version   0 : { *(.gnu.version)   }\n\
  .gnu.version_d 0 : { *(.gnu.version_d) }\n\
  .gnu.version_r 0 : { *(.gnu.version_r) }\n\
  .rel.init    0 : { *(.rel.init)  }\n\
  .rela.init   0 : { *(.rela.init) }\n\
  .rel.fini    0 : { *(.rel.fini)  }\n\
  .rela.fini   0 : { *(.rela.fini) }\n\
  .rel.text    0 : { *(.rel.text)        }\n\
  .rela.text   0 : { *(.rela.text)     }\n\
  .rel.rodata  0 : { *(.rel.rodata)    }\n\
  .rela.rodata 0 : { *(.rela.rodata) }\n\
  .rel.data    0 : { *(.rel.data)        }\n\
  .rela.data   0 : { *(.rela.data)     }\n\
  .rel.bss     0 : { *(.rel.bss)          }\n\
  .rela.bss    0 : { *(.rela.bss)       }\n\
  .rel.ctors   0 : { *(.rel.ctors)  }\n"
"  .rela.ctors  0 : { *(.rela.ctors) }\n\
  .rel.dtors   0 : { *(.rel.dtors)  }\n\
  .rela.dtors  0 : { *(.rela.dtors) }\n\
  .rel.got     0 : { *(.rel.got)    }\n\
  .rela.got    0 : { *(.rela.got)   }\n\
  .rel.plt     0 : { *(.rel.plt)    }\n\
  .rela.plt    0 : { *(.rela.plt)   }\n\
  .text :\n\
  {\n\
     . = ALIGN(2);\n\
     __ctors_start = . ;\n\
     KEEP(*(.ctors))\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     KEEP(*(.dtors))\n\
     __dtors_end = . ;\n\
    *(.text)\n\
  }\n\
  .rodata 0 :\n\
  {\n\
    *(.rodata)\n\
  }\n\
   /* Past last read-only (loadable) segment */\n\
  .data 0 :\n\
  {\n"
"    *(.data)\n\
     /* Past last read-write (loadable) segment */\n\
  }\n\
  .bss 0 :\n\
  {\n\
    *(.bss)\n\
    *(COMMON)\n\
  }\n\
  .noinit 0 :\n\
  {\n\
    *(.noinit)\n\
  }\n\
   /* Past last write (loadable) segment */\n\
  .infomem 0 :\n\
  {\n\
    *(.infomem)\n\
    *(.infomem.*)\n\
  }\n\
  .infomemnobits 0 :\n\
  {\n\
    *(.infomemnobits)\n\
    *(.infomemnobits.*)\n\
  }\n\
  .infoa 0 :\n\
  {\n"
"    *(.infoa)\n\
  }\n\
  .infob 0 :\n\
  {\n\
    *(.infob)\n\
  }\n\
  .infoc 0 :\n\
  {\n\
    *(.infoc)\n\
  }\n\
  .infod 0 :\n\
  {\n\
    *(.infod)\n\
  }\n\
  .vectors 0:\n\
  {\n\
    KEEP(*(.vectors*))\n\
  }\n\
  .fartext :\n\
  {\n\
    *(.fartext)\n\
    *(.fartext.*)\n\
  }\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n"
"  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
}\n\n"
  ; else if (link_info.relocatable) return
"/* Script for ld -r: link without relocation */\n\
OUTPUT_FORMAT(\"elf32-msp430\")\n\
OUTPUT_ARCH(\"msp430\")\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          0 : { *(.hash)          }\n\
  .dynsym        0 : { *(.dynsym)        }\n\
  .dynstr        0 : { *(.dynstr)        }\n\
  .gnu.version   0 : { *(.gnu.version)   }\n\
  .gnu.version_d 0 : { *(.gnu.version_d) }\n\
  .gnu.version_r 0 : { *(.gnu.version_r) }\n\
  .rel.init    0 : { *(.rel.init)  }\n\
  .rela.init   0 : { *(.rela.init) }\n\
  .rel.fini    0 : { *(.rel.fini)  }\n\
  .rela.fini   0 : { *(.rela.fini) }\n\
  .rel.text    0 : { *(.rel.text)        }\n\
  .rela.text   0 : { *(.rela.text)     }\n\
  .rel.rodata  0 : { *(.rel.rodata)    }\n\
  .rela.rodata 0 : { *(.rela.rodata) }\n\
  .rel.data    0 : { *(.rel.data)        }\n\
  .rela.data   0 : { *(.rela.data)     }\n\
  .rel.bss     0 : { *(.rel.bss)          }\n\
  .rela.bss    0 : { *(.rela.bss)       }\n\
  .rel.ctors   0 : { *(.rel.ctors)  }\n"
"  .rela.ctors  0 : { *(.rela.ctors) }\n\
  .rel.dtors   0 : { *(.rel.dtors)  }\n\
  .rela.dtors  0 : { *(.rela.dtors) }\n\
  .rel.got     0 : { *(.rel.got)    }\n\
  .rela.got    0 : { *(.rela.got)   }\n\
  .rel.plt     0 : { *(.rel.plt)    }\n\
  .rela.plt    0 : { *(.rela.plt)   }\n\
  .text :\n\
  {\n\
    *(.text)\n\
  }\n\
  .rodata 0 :\n\
  {\n\
    *(.rodata)\n\
  }\n\
   /* Past last read-only (loadable) segment */\n\
  .data 0 :\n\
  {\n\
    *(.data)\n\
     /* Past last read-write (loadable) segment */\n\
  }\n\
  .bss 0 :\n\
  {\n\
    *(.bss)\n\
    *(COMMON)\n"
"  }\n\
  .noinit 0 :\n\
  {\n\
    *(.noinit)\n\
  }\n\
   /* Past last write (loadable) segment */\n\
  .infomem 0 :\n\
  {\n\
    *(.infomem)\n\
    *(.infomem.*)\n\
  }\n\
  .infomemnobits 0 :\n\
  {\n\
    *(.infomemnobits)\n\
    *(.infomemnobits.*)\n\
  }\n\
  .infoa 0 :\n\
  {\n\
    *(.infoa)\n\
  }\n\
  .infob 0 :\n\
  {\n\
    *(.infob)\n\
  }\n\
  .infoc 0 :\n"
"  {\n\
    *(.infoc)\n\
  }\n\
  .infod 0 :\n\
  {\n\
    *(.infod)\n\
  }\n\
  .vectors 0:\n\
  {\n\
    KEEP(*(.vectors*))\n\
  }\n\
  .fartext :\n\
  {\n\
    *(.fartext)\n\
    *(.fartext.*)\n\
  }\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n"
"  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
}\n\n"
  ; else if (!config.text_read_only) return
"/* Script for -N: mix text and data on same page; don't align data */\n\
OUTPUT_FORMAT(\"elf32-msp430\")\n\
OUTPUT_ARCH(\"msp430\")\n\
INCLUDE memory.x\n\
INCLUDE periph.x\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash            : { *(.hash)          }\n\
  .dynsym          : { *(.dynsym)        }\n\
  .dynstr          : { *(.dynstr)        }\n\
  .gnu.version     : { *(.gnu.version)   }\n\
  .gnu.version_d   : { *(.gnu.version_d) }\n\
  .gnu.version_r   : { *(.gnu.version_r) }\n\
  .rel.init      : { *(.rel.init)  }\n\
  .rela.init     : { *(.rela.init) }\n\
  .rel.fini      : { *(.rel.fini)  }\n\
  .rela.fini     : { *(.rela.fini) }\n\
  .rel.text      : { *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)        }\n\
  .rela.text     : { *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)     }\n\
  .rel.rodata    : { *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)    }\n\
  .rela.rodata   : { *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*) }\n\
  .rel.data      : { *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)        }\n\
  .rela.data     : { *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)     }\n\
  .rel.bss       : { *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)          }\n"
"  .rela.bss      : { *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)       }\n\
  .rel.ctors     : { *(.rel.ctors)  }\n\
  .rela.ctors    : { *(.rela.ctors) }\n\
  .rel.dtors     : { *(.rel.dtors)  }\n\
  .rela.dtors    : { *(.rela.dtors) }\n\
  .rel.got       : { *(.rel.got)    }\n\
  .rela.got      : { *(.rela.got)   }\n\
  .rel.plt       : { *(.rel.plt)    }\n\
  .rela.plt      : { *(.rela.plt)   }\n\
  .text :\n\
  {\n\
     . = ALIGN(2);\n\
     KEEP(*(.init .init.*))\n\
     KEEP(*(.init0))  /* Start here after reset.               */\n\
     KEEP(*(.init1))  /* User definable.                       */\n\
     KEEP(*(.init2))  /* Initialize stack.                     */\n\
     KEEP(*(.init3))  /* Initialize hardware, user definable.  */\n\
     KEEP(*(.init4))  /* Copy data to .data, clear bss.        */\n\
     KEEP(*(.init5))  /* User definable.                       */\n\
     KEEP(*(.init6))  /* C++ constructors.                     */\n\
     KEEP(*(.init7))  /* User definable.                       */\n\
     KEEP(*(.init8))  /* User definable.                       */\n\
     KEEP(*(.init9))  /* Call main().                          */\n\
     KEEP(*(.fini9))  /* Falls into here after main(). User definable.  */\n\
     KEEP(*(.fini8))  /* User definable.                           */\n"
"     KEEP(*(.fini7))  /* User definable.                           */\n\
     KEEP(*(.fini6))  /* C++ destructors.                          */\n\
     KEEP(*(.fini5))  /* User definable.                           */\n\
     KEEP(*(.fini4))  /* User definable.                           */\n\
     KEEP(*(.fini3))  /* User definable.                           */\n\
     KEEP(*(.fini2))  /* User definable.                           */\n\
     KEEP(*(.fini1))  /* User definable.                           */\n\
     KEEP(*(.fini0))  /* Infinite loop after program termination.  */\n\
     KEEP(*(.fini .fini.*))\n\
     . = ALIGN(2);\n\
     __ctors_start = . ;\n\
     KEEP(*(.ctors))\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     KEEP(*(.dtors))\n\
     __dtors_end = . ;\n\
     . = ALIGN(2);\n\
    *(.text .text.* .gnu.linkonce.t.*)\n\
     . = ALIGN(2);\n\
  }  > REGION_TEXT\n\
  .rodata   :\n\
  {\n\
     . = ALIGN(2);\n\
    *(.rodata .rodata.* .gnu.linkonce.r.*)\n\
     . = ALIGN(2);\n"
"  }  > REGION_TEXT\n\
   _etext = .; /* Past last read-only (loadable) segment */\n\
  .data   :\n\
  {\n\
     . = ALIGN(2);\n\
     PROVIDE (__data_start = .) ;\n\
    *(.data .data.* .gnu.linkonce.d.*)\n\
     . = ALIGN(2);\n\
     _edata = . ;  /* Past last read-write (loadable) segment */\n\
  }  > REGION_DATA AT > REGION_TEXT\n\
   PROVIDE (__data_load_start = LOADADDR(.data) );\n\
   PROVIDE (__data_size = SIZEOF(.data) );\n\
  .bss   :\n\
  {\n\
     PROVIDE (__bss_start = .) ;\n\
    *(.bss .bss.*)\n\
    *(COMMON)\n\
     . = ALIGN(2);\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > REGION_DATA\n\
   PROVIDE (__bss_size = SIZEOF(.bss) );\n\
  .noinit   :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit .noinit.*)\n"
"     . = ALIGN(2);\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > REGION_DATA\n\
   . = ALIGN(2);\n\
   _end = . ;   /* Past last write (loadable) segment */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
     . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
     . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomem\n\
  .infoa   :\n\
  {\n\
    *(.infoa .infoa.*)\n\
  }  > infoa\n\
  .infob   :\n\
  {\n\
    *(.infob .infob.*)\n\
  }  > infob\n\
  .infoc   :\n\
  {\n\
    *(.infoc .infoc.*)\n\
  }  > infoc\n\
  .infod   :\n\
  {\n\
    *(.infod .infod.*)\n\
  }  > infod\n\
  .vectors  :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    KEEP(*(.vectors*))\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .fartext :\n\
  {\n\
     . = ALIGN(2);\n\
    *(.fartext)\n\
     . = ALIGN(2);\n\
    *(.fartext.*)\n\
     _efartext = .;\n\
  }  > REGION_FAR_ROM\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
   PROVIDE (__stack = ORIGIN(ram) + LENGTH(ram));\n\
   PROVIDE (__data_start_rom = _etext);\n\
   PROVIDE (__data_end_rom   = _etext + SIZEOF (.data));\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"/* Script for -n: mix text and data on same page */\n\
OUTPUT_FORMAT(\"elf32-msp430\")\n\
OUTPUT_ARCH(\"msp430\")\n\
INCLUDE memory.x\n\
INCLUDE periph.x\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash            : { *(.hash)          }\n\
  .dynsym          : { *(.dynsym)        }\n\
  .dynstr          : { *(.dynstr)        }\n\
  .gnu.version     : { *(.gnu.version)   }\n\
  .gnu.version_d   : { *(.gnu.version_d) }\n\
  .gnu.version_r   : { *(.gnu.version_r) }\n\
  .rel.init      : { *(.rel.init)  }\n\
  .rela.init     : { *(.rela.init) }\n\
  .rel.fini      : { *(.rel.fini)  }\n\
  .rela.fini     : { *(.rela.fini) }\n\
  .rel.text      : { *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)        }\n\
  .rela.text     : { *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)     }\n\
  .rel.rodata    : { *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)    }\n\
  .rela.rodata   : { *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*) }\n\
  .rel.data      : { *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)        }\n\
  .rela.data     : { *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)     }\n\
  .rel.bss       : { *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)          }\n"
"  .rela.bss      : { *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)       }\n\
  .rel.ctors     : { *(.rel.ctors)  }\n\
  .rela.ctors    : { *(.rela.ctors) }\n\
  .rel.dtors     : { *(.rel.dtors)  }\n\
  .rela.dtors    : { *(.rela.dtors) }\n\
  .rel.got       : { *(.rel.got)    }\n\
  .rela.got      : { *(.rela.got)   }\n\
  .rel.plt       : { *(.rel.plt)    }\n\
  .rela.plt      : { *(.rela.plt)   }\n\
  .text :\n\
  {\n\
     . = ALIGN(2);\n\
     KEEP(*(.init .init.*))\n\
     KEEP(*(.init0))  /* Start here after reset.               */\n\
     KEEP(*(.init1))  /* User definable.                       */\n\
     KEEP(*(.init2))  /* Initialize stack.                     */\n\
     KEEP(*(.init3))  /* Initialize hardware, user definable.  */\n\
     KEEP(*(.init4))  /* Copy data to .data, clear bss.        */\n\
     KEEP(*(.init5))  /* User definable.                       */\n\
     KEEP(*(.init6))  /* C++ constructors.                     */\n\
     KEEP(*(.init7))  /* User definable.                       */\n\
     KEEP(*(.init8))  /* User definable.                       */\n\
     KEEP(*(.init9))  /* Call main().                          */\n\
     KEEP(*(.fini9))  /* Falls into here after main(). User definable.  */\n\
     KEEP(*(.fini8))  /* User definable.                           */\n"
"     KEEP(*(.fini7))  /* User definable.                           */\n\
     KEEP(*(.fini6))  /* C++ destructors.                          */\n\
     KEEP(*(.fini5))  /* User definable.                           */\n\
     KEEP(*(.fini4))  /* User definable.                           */\n\
     KEEP(*(.fini3))  /* User definable.                           */\n\
     KEEP(*(.fini2))  /* User definable.                           */\n\
     KEEP(*(.fini1))  /* User definable.                           */\n\
     KEEP(*(.fini0))  /* Infinite loop after program termination.  */\n\
     KEEP(*(.fini .fini.*))\n\
     . = ALIGN(2);\n\
     __ctors_start = . ;\n\
     KEEP(*(.ctors))\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     KEEP(*(.dtors))\n\
     __dtors_end = . ;\n\
     . = ALIGN(2);\n\
    *(.text .text.* .gnu.linkonce.t.*)\n\
     . = ALIGN(2);\n\
  }  > REGION_TEXT\n\
  .rodata   :\n\
  {\n\
     . = ALIGN(2);\n\
    *(.rodata .rodata.* .gnu.linkonce.r.*)\n\
     . = ALIGN(2);\n"
"  }  > REGION_TEXT\n\
   _etext = .; /* Past last read-only (loadable) segment */\n\
  .data   :\n\
  {\n\
     . = ALIGN(2);\n\
     PROVIDE (__data_start = .) ;\n\
    *(.data .data.* .gnu.linkonce.d.*)\n\
     . = ALIGN(2);\n\
     _edata = . ;  /* Past last read-write (loadable) segment */\n\
  }  > REGION_DATA AT > REGION_TEXT\n\
   PROVIDE (__data_load_start = LOADADDR(.data) );\n\
   PROVIDE (__data_size = SIZEOF(.data) );\n\
  .bss   :\n\
  {\n\
     PROVIDE (__bss_start = .) ;\n\
    *(.bss .bss.*)\n\
    *(COMMON)\n\
     . = ALIGN(2);\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > REGION_DATA\n\
   PROVIDE (__bss_size = SIZEOF(.bss) );\n\
  .noinit   :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit .noinit.*)\n"
"     . = ALIGN(2);\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > REGION_DATA\n\
   . = ALIGN(2);\n\
   _end = . ;   /* Past last write (loadable) segment */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
     . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
     . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomem\n\
  .infoa   :\n\
  {\n\
    *(.infoa .infoa.*)\n\
  }  > infoa\n\
  .infob   :\n\
  {\n\
    *(.infob .infob.*)\n\
  }  > infob\n\
  .infoc   :\n\
  {\n\
    *(.infoc .infoc.*)\n\
  }  > infoc\n\
  .infod   :\n\
  {\n\
    *(.infod .infod.*)\n\
  }  > infod\n\
  .vectors  :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    KEEP(*(.vectors*))\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .fartext :\n\
  {\n\
     . = ALIGN(2);\n\
    *(.fartext)\n\
     . = ALIGN(2);\n\
    *(.fartext.*)\n\
     _efartext = .;\n\
  }  > REGION_FAR_ROM\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
   PROVIDE (__stack = ORIGIN(ram) + LENGTH(ram));\n\
   PROVIDE (__data_start_rom = _etext);\n\
   PROVIDE (__data_end_rom   = _etext + SIZEOF (.data));\n\
}\n\n"
  ; else return
"/* Default linker script, for normal executables */\n\
OUTPUT_FORMAT(\"elf32-msp430\")\n\
OUTPUT_ARCH(\"msp430\")\n\
INCLUDE memory.x\n\
INCLUDE periph.x\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash            : { *(.hash)          }\n\
  .dynsym          : { *(.dynsym)        }\n\
  .dynstr          : { *(.dynstr)        }\n\
  .gnu.version     : { *(.gnu.version)   }\n\
  .gnu.version_d   : { *(.gnu.version_d) }\n\
  .gnu.version_r   : { *(.gnu.version_r) }\n\
  .rel.init      : { *(.rel.init)  }\n\
  .rela.init     : { *(.rela.init) }\n\
  .rel.fini      : { *(.rel.fini)  }\n\
  .rela.fini     : { *(.rela.fini) }\n\
  .rel.text      : { *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)        }\n\
  .rela.text     : { *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)     }\n\
  .rel.rodata    : { *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)    }\n\
  .rela.rodata   : { *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*) }\n\
  .rel.data      : { *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)        }\n\
  .rela.data     : { *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)     }\n\
  .rel.bss       : { *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)          }\n"
"  .rela.bss      : { *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)       }\n\
  .rel.ctors     : { *(.rel.ctors)  }\n\
  .rela.ctors    : { *(.rela.ctors) }\n\
  .rel.dtors     : { *(.rel.dtors)  }\n\
  .rela.dtors    : { *(.rela.dtors) }\n\
  .rel.got       : { *(.rel.got)    }\n\
  .rela.got      : { *(.rela.got)   }\n\
  .rel.plt       : { *(.rel.plt)    }\n\
  .rela.plt      : { *(.rela.plt)   }\n\
  .text :\n\
  {\n\
     . = ALIGN(2);\n\
     KEEP(*(.init .init.*))\n\
     KEEP(*(.init0))  /* Start here after reset.               */\n\
     KEEP(*(.init1))  /* User definable.                       */\n\
     KEEP(*(.init2))  /* Initialize stack.                     */\n\
     KEEP(*(.init3))  /* Initialize hardware, user definable.  */\n\
     KEEP(*(.init4))  /* Copy data to .data, clear bss.        */\n\
     KEEP(*(.init5))  /* User definable.                       */\n\
     KEEP(*(.init6))  /* C++ constructors.                     */\n\
     KEEP(*(.init7))  /* User definable.                       */\n\
     KEEP(*(.init8))  /* User definable.                       */\n\
     KEEP(*(.init9))  /* Call main().                          */\n\
     KEEP(*(.fini9))  /* Falls into here after main(). User definable.  */\n\
     KEEP(*(.fini8))  /* User definable.                           */\n"
"     KEEP(*(.fini7))  /* User definable.                           */\n\
     KEEP(*(.fini6))  /* C++ destructors.                          */\n\
     KEEP(*(.fini5))  /* User definable.                           */\n\
     KEEP(*(.fini4))  /* User definable.                           */\n\
     KEEP(*(.fini3))  /* User definable.                           */\n\
     KEEP(*(.fini2))  /* User definable.                           */\n\
     KEEP(*(.fini1))  /* User definable.                           */\n\
     KEEP(*(.fini0))  /* Infinite loop after program termination.  */\n\
     KEEP(*(.fini .fini.*))\n\
     . = ALIGN(2);\n\
     __ctors_start = . ;\n\
     KEEP(*(.ctors))\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     KEEP(*(.dtors))\n\
     __dtors_end = . ;\n\
     . = ALIGN(2);\n\
    *(.text .text.* .gnu.linkonce.t.*)\n\
     . = ALIGN(2);\n\
  }  > REGION_TEXT\n\
  .rodata   :\n\
  {\n\
     . = ALIGN(2);\n\
    *(.rodata .rodata.* .gnu.linkonce.r.*)\n\
     . = ALIGN(2);\n"
"  }  > REGION_TEXT\n\
   _etext = .; /* Past last read-only (loadable) segment */\n\
  .data   :\n\
  {\n\
     . = ALIGN(2);\n\
     PROVIDE (__data_start = .) ;\n\
    *(.data .data.* .gnu.linkonce.d.*)\n\
     . = ALIGN(2);\n\
     _edata = . ;  /* Past last read-write (loadable) segment */\n\
  }  > REGION_DATA AT > REGION_TEXT\n\
   PROVIDE (__data_load_start = LOADADDR(.data) );\n\
   PROVIDE (__data_size = SIZEOF(.data) );\n\
  .bss   :\n\
  {\n\
     PROVIDE (__bss_start = .) ;\n\
    *(.bss .bss.*)\n\
    *(COMMON)\n\
     . = ALIGN(2);\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > REGION_DATA\n\
   PROVIDE (__bss_size = SIZEOF(.bss) );\n\
  .noinit   :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit .noinit.*)\n"
"     . = ALIGN(2);\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > REGION_DATA\n\
   . = ALIGN(2);\n\
   _end = . ;   /* Past last write (loadable) segment */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
     . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
     . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomem\n\
  .infoa   :\n\
  {\n\
    *(.infoa .infoa.*)\n\
  }  > infoa\n\
  .infob   :\n\
  {\n\
    *(.infob .infob.*)\n\
  }  > infob\n\
  .infoc   :\n\
  {\n\
    *(.infoc .infoc.*)\n\
  }  > infoc\n\
  .infod   :\n\
  {\n\
    *(.infod .infod.*)\n\
  }  > infod\n\
  .vectors  :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    KEEP(*(.vectors*))\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .fartext :\n\
  {\n\
     . = ALIGN(2);\n\
    *(.fartext)\n\
     . = ALIGN(2);\n\
    *(.fartext.*)\n\
     _efartext = .;\n\
  }  > REGION_FAR_ROM\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
   PROVIDE (__stack = ORIGIN(ram) + LENGTH(ram));\n\
   PROVIDE (__data_start_rom = _etext);\n\
   PROVIDE (__data_end_rom   = _etext + SIZEOF (.data));\n\
}\n\n"
; }

struct ld_emulation_xfer_struct ld_msp430_emulation =
{
  gldmsp430_before_parse,
  syslib_default,
  hll_default,
  after_parse_default,
  gldmsp430_after_open,
  gldmsp430_after_allocation,
  set_output_arch_default,
  ldemul_default_target,
  gldmsp430_before_allocation,
  gldmsp430_get_script,
  "msp430",
  "elf32-msp430",
  gldmsp430_finish,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,	/* add_options */
  NULL,	/* handle_option */
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
